//
//  AVR Utiltiy
//
//  ATtiny2313   2008.11.30
//
//  Importance CPU Clock 1.0MHz(8M/8)  73
//                       8.0MHz(8M/1) 584 
//
#include <avr/io.h>
#include "CPU.h"

void wait3(unsigned int time){		// 300SPʂwait[`@2600SƂȂ
  unsigned char lpcnt;
  __asm__ __volatile__("\n"
    "CPU_wait_entry:\n\t"
    "ldi %0,73\n"					//CK 12M/8=1.5MHz 110
    "CPU_wait_lp:\n\t"				//CK  8M/8=1.0MHz 73
    "nop\n\t"
    "dec %0\n\t"
    "brne CPU_wait_lp\n\t"
    "sbiw %1,1\n\t"
    "brne CPU_wait_entry\n\t"
    :"=&a"(lpcnt)
    :"w"(time)
  );
  return;
}
